<template>
    <div class="invite">
        <q-page class="row background-content">
            <div class="col-12">
                <div class="row q-px-md">
                    <div class="col-12">
                        <div
                            class="
                                page-content
                                items-center
                                q-pt-lg
                                q-pb-lg
                                q-pt-xs-none
                                q-px-sm-none
                                q-px-md-none
                                q-px-lg-xl
                            "
                            @click="state.searchResults = false"
                        >
                            <div class="row q-mt-lg items-center">
                                <div class="col-12 col-md-4 col-lg-4">
                                    <q-input
                                        outlined
                                        bottom-slots
                                        v-model="search"
                                        :label="$t('invite.search')"
                                        dense
                                        :loading="state.loadingState"
                                        debounce="500"
                                        bg-color="transparent"
                                        clearable
                                    >
                                        <template v-slot:prepend>
                                            <q-icon
                                                name="search"
                                                class="text-5B9ADD"
                                            />
                                        </template>
                                    </q-input>

                                    <!-- SEARCH RESULTS -->
                                    <div
                                        class="searchResults"
                                        v-if="state.searchResults"
                                    >
                                        <q-list class="q-pa-md">
                                            <q-item
                                                :class="
                                                    list.status == 1
                                                        ? 'active q-py-sm q-my-sm'
                                                        : 'q-py-sm q-my-sm'
                                                "
                                                :disable="
                                                    list.status == 2
                                                        ? true
                                                        : false
                                                "
                                                :clickable="
                                                    list.status == 2
                                                        ? false
                                                        : true
                                                "
                                                v-ripple
                                                v-for="(
                                                    list, index
                                                ) in state.searchList"
                                                :key="'invite-' + index"
                                                @click="selectListPressed(list)"
                                            >
                                                <q-item-section avatar>
                                                    <q-img
                                                        class="border-radius-50"
                                                        :src="
                                                            list.imageUrl
                                                                ? list.imageUrl
                                                                : '/images/default.png'
                                                        "
                                                    />
                                                </q-item-section>
                                                <q-item-section>
                                                    <q-item-label>
                                                        <p
                                                            :class="
                                                                list.status == 2
                                                                    ? 'text-invited font-16'
                                                                    : 'font-16'
                                                            "
                                                        >
                                                            {{ list.name }}
                                                            <span
                                                                v-if="
                                                                    list.status ==
                                                                    2
                                                                "
                                                                class="
                                                                    q-py-xs
                                                                    q-px-sm
                                                                    invited-pill
                                                                    text-uppercase
                                                                "
                                                            >
                                                                {{
                                                                    $t(
                                                                        'invite.alreadyInvited'
                                                                    )
                                                                }}
                                                            </span>
                                                        </p>
                                                    </q-item-label>
                                                    <q-item-label>
                                                        <p
                                                            class="
                                                                text-777777
                                                                font-16
                                                            "
                                                        >
                                                            {{ list.username }}
                                                        </p>
                                                    </q-item-label>
                                                </q-item-section>
                                            </q-item>
                                        </q-list>
                                    </div>
                                </div>
                                <div
                                    v-if="state.searchList.length > 1"
                                    class="col-4 col-md-3 col-lg-3"
                                >
                                    <p
                                        class="
                                            invitation-text
                                            font-14
                                            text-888888
                                            helvetica-neue-medium
                                            q-pa-xs
                                            text-center text-5B9ADD
                                            q-ml-xl q-pl-xl
                                        "
                                    >
                                        {{ $t('invite.pickRole') }}
                                    </p>
                                </div>
                                <div
                                    v-if="state.searchList.length > 1"
                                    class="col-4 col-md-3 col-lg-3 q-pl-lg"
                                >
                                    <p
                                        class="
                                            invitation-text
                                            font-14
                                            text-888888
                                            helvetica-neue-medium
                                            q-pa-xs q-pl-xl
                                            text-center text-5B9ADD
                                        "
                                    >
                                        Assign Branch
                                    </p>
                                </div>
                                <!--                                 <div
                                    v-if="state.searchList.length > 1"
                                    class="col-4 col-md-3 col-lg-3"
                                >
                                    <p
                                        class="
                                            invitation-text
                                            font-14
                                            text-888888
                                            helvetica-neue-medium
                                            q-pa-xs
                                            text-center
                                        "
                                    >
                                        {{ $t('invite.showSelected') }}({{
                                            state.selectedList
                                        }})
                                    </p>
                                </div> -->
                                <div
                                    v-if="state.searchList.length > 1"
                                    class="
                                        col-4 col-md-2 col-lg-2
                                        text-center
                                        q-pl-xl
                                    "
                                >
                                    <q-btn
                                        flat
                                        no-caps
                                        size="md"
                                        class="
                                            font-14
                                            text-5B9ADD
                                            helvetica-neue-medium
                                        "
                                        @click="selectAllPressed"
                                    >
                                        {{ $t('button.selectAll') }}
                                    </q-btn>
                                </div>
                            </div>

                            <!-- LIST -->
                            <div
                                class="row"
                                v-if="state.invitationList.length > 0"
                            >
                                <div
                                    class="
                                        col-12 col-md-10 col-lg-11
                                        offset-md-1
                                    "
                                >
                                    <q-list>
                                        <q-item
                                            :class="
                                                list.status == 1
                                                    ? 'active q-py-sm q-my-sm'
                                                    : 'q-py-sm q-my-sm'
                                            "
                                            :disable="
                                                list.status == 2 ? true : false
                                            "
                                            :clickable="
                                                list.status == 2 ? false : true
                                            "
                                            v-ripple
                                            v-for="(
                                                list, index
                                            ) in state.invitationList"
                                            :key="'invite-' + index"
                                        >
                                            <q-item-section
                                                class="col-1"
                                                avatar
                                                @click="
                                                    selectInvitationListPressed(
                                                        list.id
                                                    )
                                                "
                                            >
                                                <q-img
                                                    class="border-radius-50"
                                                    :src="
                                                        list.imageUrl
                                                            ? list.imageUrl
                                                            : '/images/default.png'
                                                    "
                                                />
                                            </q-item-section>
                                            <q-item-section
                                                class="col-3"
                                                @click="
                                                    selectInvitationListPressed(
                                                        list.id
                                                    )
                                                "
                                            >
                                                <q-item-label>
                                                    <p
                                                        :class="
                                                            list.status == 2
                                                                ? 'text-invited font-16'
                                                                : 'font-16'
                                                        "
                                                    >
                                                        {{ list.name }}
                                                        <span
                                                            v-if="
                                                                list.status == 2
                                                            "
                                                            class="
                                                                q-py-xs q-px-sm
                                                                invited-pill
                                                                text-uppercase
                                                            "
                                                        >
                                                            {{
                                                                $t(
                                                                    'invite.alreadyInvited'
                                                                )
                                                            }}
                                                        </span>
                                                    </p>
                                                </q-item-label>
                                                <q-item-label>
                                                    <p
                                                        class="
                                                            text-777777
                                                            font-16
                                                        "
                                                    >
                                                        {{ list.username }}
                                                    </p>
                                                </q-item-label>
                                            </q-item-section>
                                            <q-item-section class="col-3">
                                                <q-item-label class="q-mr-lg">
                                                    <q-select
                                                        class="invSelection"
                                                        v-model="
                                                            state.selectedRole[
                                                                index
                                                            ]
                                                        "
                                                        use-input
                                                        dense
                                                        borderless
                                                        input-debounce="500"
                                                        :options="state.roles"
                                                        option-value="id"
                                                        option-label="name"
                                                    >
                                                        <template
                                                            v-slot:no-option
                                                        >
                                                            <q-item>
                                                                <q-item-section
                                                                    class="
                                                                        text-grey
                                                                    "
                                                                >
                                                                    No results
                                                                </q-item-section>
                                                            </q-item>
                                                        </template>
                                                    </q-select>
                                                </q-item-label>
                                            </q-item-section>
                                            <q-item-section class="col-3" dense>
                                                <q-select
                                                    borderless
                                                    class="invSelection"
                                                    v-model="
                                                        state.selectedBranch[
                                                            index
                                                        ]
                                                    "
                                                    dense
                                                    input-debounce="500"
                                                    :label="state.header"
                                                    :options="state.branches"
                                                    option-value="id"
                                                    option-label="name"
                                                >
                                                    <template v-slot:no-option>
                                                        <q-item>
                                                            <q-item-section
                                                                class="
                                                                    text-grey
                                                                "
                                                            >
                                                                No results
                                                            </q-item-section>
                                                        </q-item>
                                                    </template>
                                                </q-select>
                                            </q-item-section>
                                            <q-item-section
                                                class="offset-md-1"
                                                avatar
                                                @click="
                                                    selectInvitationListPressed(
                                                        list.id
                                                    )
                                                "
                                            >
                                                <q-img
                                                    v-if="list.status == 2"
                                                    src="/images/selected.png"
                                                />
                                                <q-img
                                                    v-if="list.status == 1"
                                                    src="/images/select.png"
                                                />
                                                <q-img
                                                    v-else
                                                    src="/images/add.png"
                                                />
                                            </q-item-section>
                                        </q-item>
                                    </q-list>
                                </div>
                            </div>

                            <!-- EMPTY LIST -->
                            <div class="row" v-else>
                                <div class="col-12">
                                    <div
                                        class="
                                            q-mt-md-lg
                                            q-pt-md-lg
                                            q-mt-lg-xl
                                            q-pt-lg-xl
                                            text-center
                                        "
                                    >
                                        <q-img
                                            src="/images/invite.png"
                                            width="45px"
                                            height="45px"
                                        />
                                        <p
                                            class="
                                                q-py-md
                                                helvetica-neue-light
                                                font-14
                                            "
                                        >
                                            {{ $t('invite.findUser') }}
                                        </p>
                                    </div>
                                </div>
                            </div>

                            <!-- INVITE BUTTON -->
                            <div class="row">
                                <div class="col-10 offset-md-1 text-right">
                                    <q-btn
                                        v-if="
                                            state.invitationList.length > 0 &&
                                            state.invitationBtn
                                        "
                                        size="16px"
                                        label="Invite"
                                        class="
                                            border-radius-10
                                            q-px-lg
                                            bg-647BD1
                                            text-white
                                        "
                                        no-caps
                                        @click="state.confirm = true"
                                    />
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </q-page>
    </div>

    <!-- CONFIRM DIALOG -->
    <!-- <q-dialog v-model="state.confirm" persistent>
        <q-card class="border-radius-50 q-pa-lg" style="width: 300px">
            <q-card-section class="row items-center">
                <span class="q-ml-sm font-24 text-center">
                    {{ $t('invite.confirmInvites') }}
                </span>
            </q-card-section>

            <q-card-actions align="center">
                <q-btn
                    :label="$t('button.cancel')"
                    color="grey-5"
                    class="border-radius-10"
                    padding="8px 18px"
                    unelevated
                    v-close-popup
                />
                <q-btn
                    :label="$t('button.confirm')"
                    color="primary"
                    class="border-radius-10"
                    padding="8px 18px"
                    unelevated
                    @click="inviteBtnPressed"
                />
            </q-card-actions>
        </q-card>
    </q-dialog> -->

    <q-dialog v-model="state.confirm" persistent>
        <q-card class="border-radius-50 q-pa-sm" style="width: 300px">
            <q-card-section class="row items-center justify-center">
                <span class="font-24 helvetica-neue-medium">
                    {{ $t('preference.invites') }}
                </span>
            </q-card-section>

            <q-card-section class="row items-center justify-center">
                <span class="font-18 text-center helvetica-neue-medium">
                    {{ $t('invite.confirmInvites') }}
                </span>
            </q-card-section>

            <q-card-actions vertical align="center">
                <q-btn
                    :label="$t('button.invite')"
                    class="border-radius-10 helvetica-neue-medium confirm-btn"
                    text-color="white"
                    padding="8px 18px"
                    no-caps
                    @click="inviteBtnPressed"
                />
                <q-btn
                    :label="$t('button.cancel')"
                    class="border-radius-10 helvetica-neue-medium"
                    padding="8px 18px"
                    flat
                    no-caps
                    v-close-popup
                />
            </q-card-actions>
        </q-card>
    </q-dialog>

    <!-- SUCCESS DIALOG -->
    <q-dialog v-model="state.success" persistent>
        <q-card class="border-radius-50 q-pa-lg" style="width: 300px">
            <q-card-section class="row items-center">
                <span class="q-ml-sm font-24 text-center">
                    {{ $t('invite.successInvites') }}
                </span>
            </q-card-section>

            <q-card-actions align="center">
                <q-btn
                    :label="$t('button.ok')"
                    color="primary"
                    class="border-radius-10 full-width"
                    padding="8px 18px"
                    unelevated
                    v-close-popup
                />
            </q-card-actions>
        </q-card>
    </q-dialog>

    <!-- ERROR DIALOG -->
    <q-dialog v-model="state.error" persistent>
        <q-card class="border-radius-50 q-pa-lg" style="width: 300px">
            <q-card-section class="row items-center">
                <span class="q-ml-sm font-24 text-center">
                    {{ $t('invite.errorInvites') }}
                </span>
            </q-card-section>

            <q-card-actions align="center">
                <q-btn
                    :label="$t('button.retry')"
                    color="dark"
                    class="border-radius-10 full-width"
                    padding="8px 18px"
                    unelevated
                    v-close-popup
                />
            </q-card-actions>
        </q-card>
    </q-dialog>
</template>

<script lang="ts">
/* eslint-disable @typescript-eslint/no-unsafe-call */
/* eslint-disable @typescript-eslint/no-unsafe-member-access */
/* eslint-disable @typescript-eslint/no-unsafe-assignment */
import { useStore } from 'src/store';
import {
    defineComponent,
    ref,
    reactive,
    watch,
    computed,
    onMounted
} from 'vue';
import { UserSearchResponseResult } from 'src/services/responses/user/UserSearchResponse';
import { UserSearchType } from 'src/services/enums/UserSearchType';

export default defineComponent({
    name: 'Invite',
    setup() {
        // store
        const store = useStore();

        // data
        let search = ref('');

        let state = reactive({
            loadingState: ref(false),
            searchResults: ref(false),
            confirm: ref(false),
            success: ref(false),
            error: ref(false),
            invitationBtn: ref(false),
            selectedList: 0,
            searchList: [] as any,
            invitationList: [] as any,
            selectedBranch: [] as any,
            selectedRole: [] as any,
            roles: computed(() => {
                return store.state.role.role;
            }),
            branches: computed(() => {
                return store.state.branch.branches;
            })
        });

        // watch
        watch(search, async (currentValue) => {
            if (currentValue) {
                await searchFunction(currentValue);
            } else {
                state.loadingState = false;
                state.searchResults = false;
            }
        });

        // methods
        const searchFunction = async (search: string) => {
            state.loadingState = true;

            const result: UserSearchResponseResult = await store.dispatch(
                'user/search',
                {
                    type: UserSearchType.KEYWORD,
                    value: search
                }
            );

            if (result.users.length > 0) {
                state.loadingState = false;
                state.searchResults = true;
                state.searchList = result.users;
            } else {
                state.loadingState = false;
            }
        };

        const selectListPressed = (list: any) => {
            let newList = {
                id: list.id,
                name: list.name,
                imageUrl: list.imageUrl,
                status: 1
            };

            if (state.invitationList.length > 0) {
                const findIndex = state.invitationList.findIndex(
                    (element: any) => element.id == list.id
                );
                if (findIndex == -1) {
                    state.invitationList.push(newList);
                    state.selectedRole[state.invitationList.length - 1] =
                        state.roles[0];
                    state.selectedBranch[state.invitationList.length - 1] =
                        state.branches[0];
                }
            } else {
                state.invitationList.push(newList);
                state.selectedBranch[state.invitationList.length - 1] =
                    state.branches[0];
                state.selectedRole[state.invitationList.length - 1] =
                    state.roles[0];
            }

            state.selectedList = state.invitationList.length;

            // check for invitation button
            checkInvitationButton();
        };

        const selectInvitationListPressed = (id: number) => {
            const findIndex = state.invitationList.findIndex(
                (element: any) => element.id == id
            );

            if (findIndex != -1) {
                if (state.invitationList[findIndex].status == 1) {
                    state.invitationList[findIndex].status = 0;
                } else {
                    state.invitationList[findIndex].status = 1;
                }
            }

            state.selectedList = 0;

            for (const list of state.invitationList) {
                if (list.status == 1) {
                    state.selectedList = state.selectedList + 1;
                }
            }

            // check for invitation button
            checkInvitationButton();
        };

        const selectAllPressed = () => {
            state.selectedList = 0;

            for (const [index, list] of state.invitationList.entries()) {
                if (list.status != 2) {
                    state.invitationList[index].status = 1;
                    state.selectedList = state.selectedList + 1;
                    state.invitationBtn = true;
                }
            }
        };

        const checkInvitationButton = () => {
            state.invitationBtn = false;
            for (const list of state.invitationList) {
                if (list.status == 1) {
                    state.invitationBtn = true;
                }
            }
        };

        const initBranch = () => {
            state.selectedBranch.forEach((element: any) => {
                element = state.branches[0];
            });
            state.selectedBranch[0] = state.branches[0];
            state.selectedRole[0] = state.roles[0];
        };

        const inviteBtnPressed = () => {
            if (store.state.role.permissions.member?.invite) {
                state.confirm = false;

                state.invitationList.forEach((element: any, index: any) => {
                    if (!state.selectedBranch[index]) {
                        state.selectedBranch[index] = '';
                    }
                });

                let userIds = [] as any;
                let branchIds = [] as any;
                let rolesIds = '' as any;

                state.invitationList.forEach(
                    async (element: any, index: any) => {
                        if (userIds) {
                            userIds = [];
                        }
                        if (branchIds) {
                            branchIds = [];
                        }
                        if (rolesIds) {
                            rolesIds = '';
                        }

                        if (element.status == 1) {
                            userIds.push(element.id);

                            branchIds.push(state.selectedBranch[index].id);
                            rolesIds = state.selectedRole[index].id;

                            const result: any = await store.dispatch(
                                'member/inviteUser',
                                {
                                    userIds,
                                    roleId: rolesIds,
                                    branchIds
                                }
                            );

                            if (
                                result.status == 200 &&
                                state.invitationList[
                                    state.invitationList.length - 1
                                ]
                            ) {
                                // reset invitation list
                                state.invitationList = [];
                                search = ref('');

                                // success dialog
                                state.success = true;

                                // get pending members
                                getPendingList();
                            } else if (
                                state.invitationList[
                                    state.invitationList.length - 1
                                ]
                            ) {
                                state.error = true;
                            }
                        }
                    }
                );
            }
        };

        const getPendingList = async () => {
            await store.dispatch('member/getList', {
                status: 0
            });
        };

        onMounted(initBranch);

        return {
            state,
            search,
            dense: ref(true),
            selectListPressed,
            selectInvitationListPressed,
            selectAllPressed,
            inviteBtnPressed,
            initBranch
        };
    }
});
</script>
